<?xml version="1.0" encoding="UTF-8"?>
<!-- edited with XMLSpy v2006 sp2 U (http://www.altova.com) by ABB Ltd (ABB Ltd) -->
<!-- MDControl.xslt
Description:
This file contains MD Control specific templates.

Notes:
This file is compatible with the msxml / msxsl 4.0 XML parser and transform tools.

History:
2002-07-12		Original		R. Trent Garverick
2002-10-09		Add get assignment template for bool10_ty and time10_ty structure(conforms to doc)
2002-10-09		Limit returned string for getMDonsameframe to 4 characters
2002-10-11			Added GetJetVelocityMode template				RTG
2002-10-16			Added GetL1OutputTypeName and GetL1TypeName  templates	RTG
2002-10-22		change to more effecient method of locating modes (compatible only with msxsl SP1 and beyond) JRB
2003-01-02		Added weight and ash target entry mode string variables			RTG
2003-03-05		Add some functions in script fro moisture numbering	JRB
2004-02-18		Add template check for invalid characters in strings	TFM
2004-07-14		Add new template to determine if two controls are on the same frame	TFM
2004-08-18		Added new L1 Control types Dyepump and Shaftspeed	MPK
2004-09-09		Add new test for SpeedOptExists variable	PJL
2004-10-06		Find name of weight control with no downstream MFIC loop	PQT
2004-10-14			Add template to extract level 1 ActuatorName and TagName	PQT
2004-11-01			Add new test for DryerLimSpeedOptExists variable	PJL
2004-11-15			Add new Downstream loop assignment function for Speed Opt when MFIC exists		PJL
2004-11-18			Change GetAssignment to support more than 1 WT-loop (WT not hard coded to 2 anymore)		PQT
2004-12-05		add machine type variable		TFM
2004-12-10			Added consistecny compensation variable		TFM
2004-12-27		add variable for ply loading actuator name		TFM
2005-01-06		Renamed variable consistency compensation variable		DMC
2005-02-08		Added variables for NumberOfStocks and NumberOfConsistencies		DMC
2005-11-29			Remove the MDTissue variable as per PRC#1378	MPK
2007-01-09     		Added 2 new vb functions NextRowNumber and ResetNextNumber, which are called from MDHSI_Tags.xslt   FJ
2007-10-09		Added new DrylineControlExists variable			PJL
2009-05-21		Added Support for RollSet Displays							PJL	
2018-10-18		Added variables required for Tissue Control		PJL
2019-11-27		Added MDUnitsType variable to check for metric or imperial units		PJL
2022-03-03		Added External Measurements to GetFrameNo 	PT
2022-08-18		Updated GetFrameNo foe External Measurements	PT

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" exclude-result-prefixes="rs z" xmlns:rs="urn:schemas-microsoft-com:rowset" xmlns:z="#RowsetSchema" xmlns:abb="http://www.abb.com/AutomationTechnologyProducts" xmlns:msxsl="urn:schemas-microsoft-com:xslt">
	<xsl:import href="NodeTypes.xslt"/>

	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
<!-- 	*********************************************************************************************************************
		Quality Control System Machine Types
		
		Note: Must match tblMDMachineTypes table in joconfig.mdb
		
	*********************************************************************************************************************
	-->
	<xsl:variable name="MDSingleStock" select="1"/>	
	<xsl:variable name="MDMultiStock" select="2"/>
	
<!-- 	*********************************************************************************************************************
		Quality Control System Units Types
		
		Note: Must match tblUnits table in joconfig.mdb
		
	*********************************************************************************************************************
	-->
	<xsl:variable name="UnitsEnglish" select="1"/>	
	<xsl:variable name="UnitsMetric" select="2"/>
	
	<!-- 	*********************************************************************************************************************
		Quality Control System Scan Level Control Types
		
		Note: Must match tblScanLevelControlTypes table in joconfig.mdb
		
		*********************************************************************************************************************
	-->
	<xsl:variable name="MDWeight" select="1"/>
	<xsl:variable name="MDMoisture" select="2"/>
	<xsl:variable name="MDAsh" select="3"/>
	<xsl:variable name="MDOpacity" select="4"/>
	<xsl:variable name="MDGloss" select="5"/>
	<xsl:variable name="MDCoatWeight" select="6"/>
	<xsl:variable name="MDYankeeHood" select="7"/>
	<xsl:variable name="MDOptional" select="9999"/>
	<!-- 	*********************************************************************************************************************
		Quality Control System  Level I Control Types
	
		Note: Must match tblLevel1ControlTypes table in joconfig.mdb
		Note: These same numbers should be used for just measurements (no level 1 control)
	
		*********************************************************************************************************************
	-->
	<xsl:variable name="L1Stock" select="1"/>
	<xsl:variable name="L1Steam" select="2"/>
	<xsl:variable name="L1Speed" select="3"/>
	<xsl:variable name="L1Clay" select="4"/>
	<xsl:variable name="L1Titanium" select="5"/>
	<xsl:variable name="L1CoaterBlade" select="6"/>
	<xsl:variable name="L1RatioBias" select="7"/>
	<xsl:variable name="L1Temperature" select="8"/>
	<xsl:variable name="L1Consistency" select="9"/>
	<xsl:variable name="L1HeadboxLevel" select="10"/>
	<xsl:variable name="L1Recirculation" select="11"/>
	<xsl:variable name="L1StreamFlow" select="12"/>
	<xsl:variable name="L1Slice" select="13"/>
	<xsl:variable name="L1AirPad" select="14"/>
	<xsl:variable name="L1TotalHead" select="15"/>
	<xsl:variable name="L1ReelSpeed" select="16"/>
	<xsl:variable name="L1WireSpeed" select="17"/>
	<xsl:variable name="L1DyePump" select="18"/>
	<xsl:variable name="L1ShaftSpeed" select="19"/>
	<xsl:variable name="L1HoodTemperature" select="20"/>
	<xsl:variable name="L1YankeeSteam" select="21"/>
	<xsl:variable name="L1Other" select="9999"/>
	<!-- 
	******************************************************
		Global Variables used in all the md control style sheets	
	****************************************************** 
	-->
	<!-- ply loading control actuator name -->
	<xsl:variable name="MDPlyLoadingName">
		<xsl:value-of select="'PL01'"/>
	</xsl:variable>
	<!-- Machine type -->
	<xsl:variable name="MDMachineType">
		<xsl:value-of select="/xml/rs:data/z:row/@MachineType"/>
	</xsl:variable>
	<!-- MD Units -->
	<xsl:variable name="MDUnitsType">
		<xsl:value-of select="/xml/rs:data/z:row/@Units"/>
	</xsl:variable>
	<!-- Weight and Ash target entry modes -->
	<xsl:variable name="WTModeString">
		<xsl:choose>
			<xsl:when test="//z:row/@WeightTargetEntryMode=0">Basis Weight</xsl:when>
			<xsl:when test="//z:row/@WeightTargetEntryMode=1">Conditioned Weight</xsl:when>
			<xsl:otherwise>Illegal Weight Target Entry Mode</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="AshModeString">
		<xsl:choose>
			<xsl:when test="//z:row/@AshTargetEntryMode=1">Conditioned Weight</xsl:when>
			<xsl:when test="//z:row/@AshTargetEntryMode=2">Basis Weight</xsl:when>
			<xsl:when test="//z:row/@AshTargetEntryMode=3">Ash Weight</xsl:when>
			<xsl:otherwise>Illegal Ash Target Entry Mode</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- MIT Node name -->
	<xsl:variable name="MITNode">
		<xsl:for-each select="/xml/rs:data/z:row/tblNodes">
			<xsl:if test="@NodeType=$MainNode">
				<xsl:value-of select="@NodeName"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>
	<!-- -->
	<!-- AC800 OPC Server Node name -->
	<xsl:variable name="AC800Node">
		<xsl:variable name="Found">
			<xsl:for-each select="/xml/rs:data/z:row/tblNodes">
				<xsl:if test="@NodeID=/xml/rs:data/z:row/@AC800M">
					<xsl:value-of select="@NodeName"/>
				</xsl:if>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$Found=''">
				<xsl:message terminate="yes">AC800 OPC Node type not found!!!</xsl:message>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$Found"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- -->
	<!-- -->
	<!-- -->
	<xsl:variable name="MD_Node">01</xsl:variable>
	<xsl:variable name="MD_Machine">
		<xsl:value-of select="/xml/rs:data/z:row/@MachineName"/>
	</xsl:variable>
	<!-- -->
	<xsl:variable name="ProjectName">
		<xsl:value-of select="$MD_Machine"/>MD<xsl:value-of select="$MD_Node"/>
	</xsl:variable>
	<xsl:variable name="AppName">Application_<xsl:value-of select="$MD_Machine"/>MD<xsl:value-of select="$MD_Node"/>
	</xsl:variable>
	<xsl:variable name="ControllerName">Controller_<xsl:value-of select="$MD_Machine"/>NOD<xsl:value-of select="$MD_Node"/>
	</xsl:variable>
	<!-- -->
	<!-- for those variables searching tables for a type, only the first 4 characters will be returned incase of multiple types -->
	<!-- Stock name -->
	<xsl:variable name="StockName">
		<xsl:variable name="WeightAct">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDWeight]/@Level1Control"/>
		</xsl:variable>
		<xsl:variable name="Found">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$WeightAct]/@ActuatorName"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$MDMachineType=$MDMultiStock and count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDWeight]) &gt; 0">
				<xsl:value-of select="$MDPlyLoadingName"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$Found=''">
						<xsl:message terminate="no">StockLevel 1 not found !!!</xsl:message>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$Found"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- Stock name -->
	<xsl:variable name="NumberOfStocks">
		<xsl:value-of select="count(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Stock])"/>
	</xsl:variable>
	<!-- Stock name -->
	<xsl:variable name="NumberOfConsistencies">
		<xsl:variable name="ConsisInL1">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Consistency])"/>
		</xsl:variable>
		<xsl:variable name="ConsisInMeas">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblLevel1Measurements[@Type=$L1Consistency])"/>
		</xsl:variable>
		<xsl:value-of select="$ConsisInL1 + $ConsisInMeas"/>
	</xsl:variable>
	<!-- Speed name -->
	<xsl:variable name="SpeedName">
		<xsl:variable name="Found">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Speed]/@ActuatorName"/>
		</xsl:variable>
		<xsl:variable name="FoundinMeas">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Measurements[@Type=$L1Speed]/@ActuatorName"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="not($Found='')">
				<xsl:value-of select="$Found"/>
			</xsl:when>
			<xsl:when test="not($FoundinMeas='')">
				<xsl:value-of select="$FoundinMeas"/>
			</xsl:when>
		</xsl:choose>
	</xsl:variable>
	<!-- REEL SPEED NAME -->
	<xsl:variable name="ReelSpeedName">
		<xsl:for-each select="/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1ReelSpeed]">
			<xsl:value-of select="@ActuatorName"/>
		</xsl:for-each>
	</xsl:variable>
	<!-- YANKEE PRESSURE NAME -->
	<xsl:variable name="YankeeSteamName">
		<xsl:for-each select="/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1YankeeSteam]">
			<xsl:value-of select="@ActuatorName"/>
		</xsl:for-each>
	</xsl:variable>
	<!-- PJL: 25May2005: Added L1SpeedCtrlExists and L1SpeedMeasExists variables -->
	<!-- Level 1 speed control exists -->
	<xsl:variable name="L1SpeedCtrlExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Speed]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- Level 1 speed measurement exists -->
	<xsl:variable name="L1SpeedMeasExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblLevel1Measurements[@Type=$L1Speed]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- Simulator Speed name -->
	<!-- Simulator must always include speed, but that actuator may be in the level 1 table as a
	different name. This tries to get the speed actuator name and if it does not exist, assumes MS01 -->
	<xsl:variable name="SimSpeedName">
		<xsl:choose>
			<xsl:when test="not($SpeedName='')">
				<xsl:value-of select="$SpeedName"/>
			</xsl:when>
			<xsl:otherwise>MS01</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- this is to configure a weight and a stock even if they do not exist in the joconfig -->
	<xsl:variable name="SimStockName">
		<xsl:choose>
			<xsl:when test="not($StockName='')">
				<xsl:value-of select="$StockName"/>
			</xsl:when>
			<xsl:otherwise>ST01</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- -->
	<xsl:variable name="SimWeightName">
		<xsl:choose>
			<xsl:when test="not($WeightName='')">
				<xsl:value-of select="$WeightName"/>
			</xsl:when>
			<xsl:otherwise>DW01</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- -->
	<!-- Drystock Exists -->
	<xsl:variable name="DrystockExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@Drystock"/>
	</xsl:variable>
	<!-- Consistecny Compensation Exists -->
	<xsl:variable name="ConsistencyCompensationExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@ConsistencyCompensation"/>
	</xsl:variable>
	<!-- AGCExists -->
	<xsl:variable name="AGCExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@AGC"/>
	</xsl:variable>
	<!-- FastGCExists -->
	<xsl:variable name="FastGCExists">False</xsl:variable>
	<!-- DryerExists -->
	<xsl:variable name="DryerExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@Dryer"/>
	</xsl:variable>
	<!-- DryerLoading is true if RB loops are present, else assume dryer is only to get sheetbreak reduction -->
	<xsl:variable name="DryerLoading">
		<xsl:variable name="Found">
			<xsl:call-template name="FindL1orMeas">
				<xsl:with-param name="ID" select="$L1RatioBias"/>
			</xsl:call-template>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="not($Found='') and $DryerExists = 'True'">
				<xsl:value-of select="'True'"/>
			</xsl:when>
			<xsl:otherwise>False</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<!-- -->
	<!-- SpeedExists -->
	<xsl:variable name="SpeedExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@Speed"/>
	</xsl:variable>
	<!-- -->
	<!-- ADDED FOR SPEED OPT -->
	<!-- -->
	<!-- SpeedOptExists -->
	<xsl:variable name="SpeedOptExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@SpeedOpt"/>
	</xsl:variable>	
	<!-- -->
	<!-- -->
	<!-- ADDED FOR DRYER LIMITED SPEED OPT -->
	<!-- -->
	<!-- DryerLimSpeedOptExists -->
	<xsl:variable name="DryerLimSpeedOptExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@DryerLimitedSpeedOpt"/>
	</xsl:variable>	
	<!-- -->
	<!-- ADDED FOR CREPE CONTROL -->
	<!-- -->
	<!-- CrepeControlExists -->
	<xsl:variable name="CrepeControlExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@CrepeControl"/>
	</xsl:variable>
	<!-- -->
	<!-- -->
	<!-- -->
	<!-- At least one scan level control exists -->
	<!-- -->
	<xsl:variable name="ScanLevelExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- -->
	<!-- Weight exists -->
	<!-- -->
	<xsl:variable name="WeightExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDWeight]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- CoatWeight exists -->
	<!-- -->
	<xsl:variable name="CoatWeightExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDCoatWeight]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- Opacity exists -->
	<!-- -->
	<xsl:variable name="OpacityExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDOpacity]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- Ash exists -->
	<!-- -->
	<xsl:variable name="AshExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDAsh]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- -->
	<!-- Yankee Hood exists -->
	<!-- -->
	<xsl:variable name="YankeeHoodExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDYankeeHood]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!-- RollSet exists -->
	<!-- -->
	<xsl:variable name="RollSetExists">
		<xsl:if test="/xml/rs:data/z:row/tblRollSet">
			<xsl:value-of select="'True'"/>
		</xsl:if>
	</xsl:variable>
	<!-- 
	<xsl:variable name="RollSetExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblRollSet) &gt; 0">True</xsl:if>
	</xsl:variable> -->
	<!-- -->
	<!-- -->
	<!-- Weight name -->
	<!-- -->
	<xsl:variable name="WeightName">
<!--
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDWeight]/@Name,1,4)"/>
-->
		<!-- pqt, 06/10/04: Find name of weight control with no downstream MFIC loop -->
		<xsl:for-each select="/xml/rs:data/z:row/tblScanLevelControls">
			<xsl:if test="@Type=$MDWeight and @MFICDownStreamLoop='None'">
				<xsl:value-of select="substring(@Name,1,4)"/>
			</xsl:if>
		</xsl:for-each>
	</xsl:variable>
	<!-- -->
	<!-- Ash name -->
	<!-- -->
	<xsl:variable name="AshName">
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDAsh]/@Name,1,4)"/>
	</xsl:variable>
	<!-- -->
	<!-- Coat Weight name -->
	<!-- -->
	<xsl:variable name="CoatWeightName">
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDCoatWeight]/@Name,1,4)"/>
	</xsl:variable>
	<!-- -->
	<!-- Clay name -->
	<!-- -->
	<xsl:variable name="ClayName">
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Clay]/@ActuatorName,1,4)"/>
	</xsl:variable>
	<!-- -->
	<!-- Titanium name -->
	<!-- -->
	<xsl:variable name="TitaniumName">
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$L1Titanium]/@ActuatorName,1,4)"/>
	</xsl:variable>
	<!-- -->
	<!-- HeadboxExists-->
	<xsl:variable name="HeadboxExists">
		<xsl:value-of select="/xml/rs:data/z:row/tblAdvancedControls/@Headbox"/>
	</xsl:variable>
	<!-- -->
	<!-- Dryline control exists -->
	<xsl:variable name="DrylineControlExists">
		<xsl:if test="count(/xml/rs:data/z:row/tblHeadboxControls[@OptDryline>0]) &gt; 0">True</xsl:if>
	</xsl:variable>
	<!-- -->
	<!--wttgt  1 = condition weight entry 0 = basis weight entry -->
	<xsl:variable name="WTTGT" select="/xml/rs:data/z:row/@WeightTargetEntryMode"/>
	<!-- 
	***********************************************************************
		Global Templates used in all the md control style sheets	
	*********************************************************************** 
	-->
	<!--
	 ******************************************************
	Script - MS Extension
	******************************************************		
	-->
	<msxsl:script language="VBScript" implements-prefix="abb"><![CDATA[ 
        Option Explicit
	
	Dim IDNumber						'ID Number
	Dim CalledOnce						'flag for random number generation	
	Dim randnum1
	Dim randnum2
	Dim MOPosNumber				'pos Number
	Dim InputNumber
	Dim NextRow
	Dim RollSet_LeftMeas
	Dim RollSet_RightMeas
	Dim RSMEASNum
	Dim RSMEASDict
	
	RSMEASNum = 0
	Set RSMEASDict = CreateObject("Scripting.Dictionary")
	InputNumber = 0
	NextRow = 1
	
	'---------------------------------------------------------------------------------------------------
	'	Generate sequential ID numbers
	'---------------------------------------------------------------------------------------------------
	Function NextIDNumber
		On Error Resume Next
		if IDNumber < 32769 then IDNumber= 32768
		IDNumber = IDNumber + 1
		NextIDNumber = IDNumber	
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'	Initialize moisture number
	'---------------------------------------------------------------------------------------------------
	Function SetMOPosNumber(n)
		On Error Resume Next
		MOPosNumber= n
		SetMOPosNumber = n
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'	Generate Input numbers
	'---------------------------------------------------------------------------------------------------
	Function NextInputNumber()
		On Error Resume Next
		InputNumber = InputNumber + 1
		NextInputNumber = InputNumber	
	End Function	
	
	'---------------------------------------------------------------------------------------------------
	'	Generate Input numbers + 3
	'---------------------------------------------------------------------------------------------------
	Function NextColorLine()
		On Error Resume Next
		InputNumber = InputNumber + 3
		NextColorLine = InputNumber	
	End Function	
	
	'---------------------------------------------------------------------------------------------------
	'	Reset Input Numbers after use
	'---------------------------------------------------------------------------------------------------
	Function ResetInputNumber()
		On Error Resume Next
		InputNumber = 0
		ResetInputNumber = InputNumber
	End Function	
	
	'---------------------------------------------------------------------------------------------------
	'	Generate Input numbers starting at 2
	'---------------------------------------------------------------------------------------------------
	Function NextRowNumber()
		On Error Resume Next
		NextRow = NextRow +1
		NextRowNumber = NextRow	
	End Function		
	
    '---------------------------------------------------------------------------------------------------
	'	Reset Input Numbers starting at 2
	'---------------------------------------------------------------------------------------------------
	Function ResetNextRow()
		On Error Resume Next
		NextRow = 1
		ResetNextRow = NextRow
	End Function	
		
	'---------------------------------------------------------------------------------------------------
	'     Imcrement moisture  number by a parameter (0 will return value)
	'---------------------------------------------------------------------------------------------------
	Function NextMOPosNumber(n)
		On Error Resume Next
		MOPosNumber= MOPosNumber + n
		NextMOPosNumber = MOPosNumber
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'	Generate a 32 bit random number
	'---------------------------------------------------------------------------------------------------
	Function GetRandom
		if CalledOnce then
		else
			Randomize
		end if
		randnum1 = Rnd
		randnum2 = Rnd
	        GetRandom = Fix((2147483647 * randnum1 + 32767 * randnum1) - (2147483647 * randnum2 + 32767 * randnum2))
	End Function
	
	 '---------------------------------------------------------------------------------------------------
	' Invoke DeleteFile DOS Command
	'---------------------------------------------------------------------------------------------------
	Function DeleteFile(FileString)
		On Error Resume Next
			Dim fso
		Set fso = CreateObject("Scripting.FileSystemObject")
			
		If Err.Number = 0 Then 
	
			fso.deletefile FileString
         
		End If
		DeleteFile = Cstr("Delete: " & FileString & " Err. No:" & Err.Number)

	End Function
	
	'---------------------------------------------------------------------------------------------------
	'     Used to find left meas (first meas) for rollset based on package number
	'---------------------------------------------------------------------------------------------------
	Function NextRollSet_LeftMeas()
		On Error Resume Next
		RollSet_LeftMeas= ((InputNumber-1)*2)+1
		NextRollSet_LeftMeas = RollSet_LeftMeas
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'     Used to find left meas (second meas) for rollset based on package number
	'---------------------------------------------------------------------------------------------------
	Function NextRollSet_RightMeas()
		On Error Resume Next
		RollSet_RightMeas= InputNumber*2
		NextRollSet_RightMeas = RollSet_RightMeas
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'     Used to find rollset meas index for rollset
	'---------------------------------------------------------------------------------------------------
	Function NextRollSet_Meas(id)
		On Error Resume Next
		dim key
		dim found
		found = 0

		for each key in RSMEASDict
			if key=id then
				found = 1
				NextRollSet_Meas = RSMEASDict(key)
			end if
		next
		
		if found=0 then
			RSMEASNum = RSMEASNum + 1
			RSMEASDict.Add id, RSMEASNum
			NextRollSet_Meas = RSMEASNum
		end if
	End Function
	
	'---------------------------------------------------------------------------------------------------
	'     Reset roll set measurement dictionary after use
	'---------------------------------------------------------------------------------------------------
	Function ResetRollSet_Meas()
		On Error Resume Next
		RSMEASNum = 0
		RSMEASDict.RemoveAll
		set RSMEASDict = Nothing
		set RSMEASDict = CreateObject("Scripting.Dictionary")
		ResetRollSet_Meas = RSMEASNum
	End Function
	
	]]></msxsl:script>
	<!-- -->
	<!-- -->
	<!-- -->
	<!--
	 *********************************************************************************************************************
	MD_Nickname
	Returns a Name  (Stock, Pressure 1) for Control Name passed as parameter
	*********************************************************************************************************************	
	-->
	<xsl:template name="MD_Nickname">
		<xsl:param name="Name"/>
		<xsl:variable name="L2Desc">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@Description"/>
		</xsl:variable>
		<xsl:variable name="L1Desc">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@ActuatorName=$Name]/@Description"/>
		</xsl:variable>
		<xsl:variable name="L2Type">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@Type"/>
		</xsl:variable>
		<xsl:variable name="L1Type">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@ActuatorName=$Name]/@ControlType"/>
		</xsl:variable>
		<xsl:choose>
			<!-- use descriptions in joconfig if found, othewise make up own -->
			<xsl:when test="not($L2Desc='')">
				<xsl:value-of select="$L2Desc"/>
			</xsl:when>
			<xsl:when test="not($L1Desc='')">
				<xsl:value-of select="$L1Desc"/>
			</xsl:when>
			<!-- -->
			<xsl:when test="$L2Type=$MDOpacity">Opacity</xsl:when>
			<xsl:when test="$L2Type=$MDWeight">Weight</xsl:when>
			<xsl:when test="$L2Type=$MDMoisture">Moisture <xsl:value-of select="substring($Name,4,1)"/>
			</xsl:when>
			<xsl:when test="$L2Type=$MDAsh">Ash</xsl:when>
			<xsl:when test="$L2Type=$MDGloss">Gloss</xsl:when>
			<xsl:when test="$L2Type=$MDCoatWeight">Coat Weight</xsl:when>
			<xsl:when test="$L2Type=$MDOptional">Optional loop <xsl:value-of select="substring($Name,4,1)"/>
			</xsl:when>
			<!-- -->
			<!-- <xsl:when test="$L1Type=$L1Stock">Stock</xsl:when> -->
			<xsl:when test="contains($Name, 'PL') or $L1Type=$L1Stock">
				<xsl:if test="$MDMachineType = $MDMultiStock">
					<xsl:text>Ply Loading</xsl:text>
				</xsl:if>
				<xsl:if test="$MDMachineType != $MDMultiStock">
					<xsl:text>Stock</xsl:text>
				</xsl:if>
			</xsl:when>
			<xsl:when test="contains($Name, 'PR') or $L1Type=$L1Steam">
				<xsl:text>Pressure </xsl:text>
				<xsl:value-of select="substring($Name,4,1)"/>
			</xsl:when>
			<xsl:when test="contains($Name, 'RB') or $L1Type=$L1RatioBias">
				<xsl:text>Bias Pressure </xsl:text>
				<xsl:value-of select="substring($Name,4,1)"/>
			</xsl:when>
			<xsl:when test="$L1Type=$L1CoaterBlade">
				<xsl:text>Coater Blade </xsl:text>
				<xsl:value-of select="substring($Name,4,1)"/>
			</xsl:when>
			<xsl:when test="$L1Type=$L1Speed">Speed</xsl:when>
			<xsl:when test="$L1Type=$L1Clay">Clay</xsl:when>
			<xsl:when test="$L1Type=$L1Titanium">Titanium</xsl:when>
			<xsl:when test="$L1Type=$L1Temperature">Temperature</xsl:when>
			<xsl:when test="$L1Type=$L1Consistency">Consistency</xsl:when>
			<xsl:when test="$L1Type=$L1HeadboxLevel">Headbox level</xsl:when>
			<xsl:when test="$L1Type=$L1Recirculation">Recirculation</xsl:when>
			<xsl:when test="$L1Type=$L1StreamFlow">Stream flow</xsl:when>
			<xsl:when test="$L1Type=$L1Slice">Slice</xsl:when>
			<xsl:when test="$L1Type=$L1AirPad">Air Pad</xsl:when>
			<xsl:when test="$L1Type=$L1TotalHead">Total Head</xsl:when>
			<xsl:when test="$L1Type=$L1ReelSpeed">Reel Speed</xsl:when>
			<xsl:when test="$L1Type=$L1WireSpeed">Wire Speed</xsl:when>
			<xsl:when test="$L1Type=$L1Other">Other</xsl:when>
			<xsl:when test="contains($Name, 'SP')">Speed</xsl:when>
			<xsl:when test="contains($Name, 'HB')">Headbox</xsl:when>
			<xsl:when test="contains($Name, 'RD')">Headbox</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$Name"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- -->
	
	<!-- -->
	<!-- Get MD control of specified type on same frame -->
	<!-- -->
	<xsl:template name="GetMDonSameFrame">
		<xsl:param name="Name"/>
		<xsl:param name="Type"/>
		<!-- get ID of  measurement -->
		<xsl:variable name="MeasId">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@MeasurementID"/>
		</xsl:variable>
		<!-- get ID of  measurement's scanner -->
		<xsl:variable name="FrameID">
			<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
				<xsl:for-each select="tblMeasurements">
					<xsl:if test="$MeasId=@MeasurementID">
						<xsl:value-of select="@ScannerID"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<!-- search all scan level controls for requested md type -->
		<xsl:for-each select="/xml/rs:data/z:row/tblScanLevelControls">
			<xsl:if test="@Type=$Type">
				<!-- Found one, get its measurement id -->
				<xsl:variable name="CandMeasid">
					<xsl:value-of select="@MeasurementID"/>
				</xsl:variable>
				<!-- and get its scanner id -->
				<xsl:variable name="CandFrameID">
					<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
						<xsl:for-each select="tblMeasurements">
							<xsl:if test="$CandMeasid=@MeasurementID">
								<xsl:value-of select="@ScannerID"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:variable>
				<!-- if candidate scanner id matches that of original md control's scanner id then return Name -->
				<xsl:if test="$CandFrameID=$FrameID">
					<xsl:value-of select="@Name"/>
				</xsl:if>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- Determine if two MD controls are on the same frame -->
	<!-- -->
	<xsl:template name="IsMDonSameFrame">
		<!-- template used to determine if control Name1 and control Name 2 are on same frame -->
		<!-- IsMDonSameFrame will be eithere 'True' or 'False' -->
		<xsl:param name="Name1"/>
		<xsl:param name="Name2"/>
		<!-- get ID of  measurement -->
		<xsl:variable name="MeasId1">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name1]/@MeasurementID"/>
		</xsl:variable>
		<xsl:variable name="MeasId2">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name2]/@MeasurementID"/>
		</xsl:variable>
		<!-- get ID of  measurement's scanner -->
		<xsl:variable name="FrameID1">
			<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
				<xsl:for-each select="tblMeasurements">
					<xsl:if test="$MeasId1=@MeasurementID">
						<xsl:value-of select="@ScannerID"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<xsl:variable name="FrameID2">
			<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
				<xsl:for-each select="tblMeasurements">
					<xsl:if test="$MeasId2=@MeasurementID">
						<xsl:value-of select="@ScannerID"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$FrameID1=$FrameID2">
				<xsl:value-of select="'True'"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="'False'"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- Get Frame number given the ID of a measurement -->
	<!-- Changed for External MD Measurement  PT-->
	<!-- -->
	<xsl:template name="GetFrameNo">
		<xsl:param name="ID"/>
		<xsl:variable name="FrameID">
			<xsl:for-each select="/xml/rs:data/z:row/tblExtMDMeasurements">
				<xsl:if test="$ID=@ExtMDMeasID">
					<xsl:value-of select="@ExtMDMeasScanner"/>
					<xsl:variable name="MeasurementType" select="ExternalMD"/>
				</xsl:if>
			</xsl:for-each>
			<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
				<xsl:for-each select="tblMeasurements">
					<xsl:if test="$ID=@MeasurementID">
						<xsl:value-of select="@ScannerID"/>
						<xsl:variable name="MeasurementType" select="@MeasurementTypeID"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$FrameID='-1'">
				<xsl:value-of select="EM"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="/xml/rs:data/z:row/tblScanners">
					<xsl:if test="$FrameID=@ScannerID">
						<xsl:value-of select="@oNum"/>
					</xsl:if>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!-- -->
		<!-- Template to define the External MD input 20220518 PT  -->
	<xsl:template name="GetMDEMType">
		<xsl:param name="ID"/>
		<xsl:value-of select="/xml/rs:data/z:row/tblExtMDMeasurements[@ExtMDMeasID=$ID]/@ExtMDMeasConfigType"/>
	</xsl:template>
	<xsl:template name="GetEMName">
		<xsl:param name="ID"/>
		<xsl:value-of select="/xml/rs:data/z:row/tblExtMDMeasurements[@ExtMDMeasID=$ID]/@ExtMDMeasName"/>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- -->
	<!-- Get Level2 control 's assigned level 1name -->
	<!-- -->
	<xsl:template name="GetL1">
		<xsl:param name="Name"/>
		<!-- find level 1 instance that the level 2 is controlling and pick out the name -->
		<xsl:variable name="L1ID">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@Level1Control"/>
		</xsl:variable>
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$L1ID]/@ActuatorName,1,4)"/>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- Get Level1 TagName by passing the Level1ID -->
	<!-- -->
	<xsl:template name="GetL1TagName">
		<xsl:param name="ID"/>
		<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$ID]/@TagName"/>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- Get Level1 ActuatorName by passing the Level1ID -->
	<!-- -->
	<xsl:template name="GetL1ActuatorName">
		<xsl:param name="ID"/>
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$ID]/@ActuatorName,1,4)"/>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- Get Level1s control 's assigned level 2 name given the ID of the level 1 -->
	<!-- -->
	<xsl:template name="GetL2">
		<xsl:param name="ID"/>
		<!-- find level 1 instance that the level 2 is controlling and pick out the name -->
		<xsl:value-of select="substring(/xml/rs:data/z:row/tblScanLevelControls[@Level1Control=$ID]/@Name,1,4)"/>
	</xsl:template>
	<!-- -->
	<!-- Get Level2 control 's assigned level 1Control Type -->
	<!-- -->
	<xsl:template name="GetL1Type">
		<xsl:param name="Name"/>
		<!-- find level 1 instance that the level 2 is controlling and pick out the name -->
		<xsl:variable name="L1ID">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@Level1Control"/>
		</xsl:variable>
		<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$L1ID]/@ControlType"/>
	</xsl:template>
	<!-- -->
	<!-- Get a name in either Level1 controls or level1 measurements given a level 1Control Type -->
	<!-- -->
	<xsl:template name="FindL1orMeas">
		<xsl:param name="ID"/>
		<xsl:variable name="FoundinL1">
			<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@ControlType=$ID]/@ActuatorName,1,4)"/>
		</xsl:variable>
		<xsl:variable name="FoundinMeas">
			<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Measurements[@Type=$ID]/@ActuatorName,1,4)"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="not($FoundinL1='')">
				<xsl:value-of select="$FoundinL1"/>
			</xsl:when>
			<xsl:when test="not($FoundinMeas='')">
				<xsl:value-of select="$FoundinMeas"/>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- Get a name in either Level1 controls or level1 measurements given a level 1Control Type -->
	<xsl:template name="FindL1orMeasWithHeadboxInstance">
		<xsl:param name="ID"/>
		<xsl:param name="ControlName"/>
		<!-- -->
		<xsl:variable name="ActNameFoundinL1">
			<xsl:for-each select="/xml/rs:data/z:row/tblLevel1Controls">
				<xsl:choose>
					<xsl:when test="@ControlType=$ID and @ActuatorName=$ControlName">
						<xsl:value-of select="$ControlName"/>
					</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<!-- -->
		<xsl:variable name="ActNameFoundinMeas">
			<xsl:for-each select="/xml/rs:data/z:row/tblLevel1Measurements">
				<xsl:choose>
					<xsl:when test="@Type=$ID and @ActuatorName=$ControlName">
						<xsl:value-of select="$ControlName"/>
					</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:variable>
		<!-- -->
		<xsl:choose>
			<xsl:when test="not($ActNameFoundinL1='')">
				<xsl:value-of select="$ActNameFoundinL1"/>
			</xsl:when>
			<xsl:when test="not($ActNameFoundinMeas='')">
				<xsl:value-of select="$ActNameFoundinMeas"/>
			</xsl:when>
		</xsl:choose>
		<!-- -->
	</xsl:template>
	 <!-- -->
	<!-- Find Rush drag acutator Name -->
	<!-- -->
	<xsl:template name="FindRushdragActuatorName">
		<xsl:param name="ControlID"/>
		<xsl:variable name="RDAName">
			<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$ControlID]/@ActuatorName,1,4)"/>
		</xsl:variable>
		<xsl:value-of select="$RDAName"/>
	</xsl:template>
	<!-- -->
	<!-- Find dryline actuator name -->
	<!-- -->
	<xsl:template name="FindDrylineActuatorName">
		<xsl:param name="OptDrylineID"/>
		<xsl:variable name="DLAName">
			<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$OptDrylineID]/@ActuatorName,1,4)"/>
		</xsl:variable>
		<xsl:value-of select="$DLAName"/>
	</xsl:template>
	<!-- -->
	<!-- Find dryline actuator name -->
	<!-- -->
	<xsl:template name="FindDrylineControlType">
		<xsl:param name="OptDrylineID"/>
		<xsl:variable name="DLType">
			<xsl:value-of select="/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$OptDrylineID]/@ControlType"/>
		</xsl:variable>
		<xsl:value-of select="$DLType"/>
	</xsl:template>
	<!-- -->
	<!-- Find Wire Speed for headbox -->
	<!-- -->
	<xsl:template name="FindWireSpeed">
		<xsl:param name="WireSpeedID"/>
		<xsl:variable name="WS">
			<xsl:value-of select="substring(/xml/rs:data/z:row/tblLevel1Controls[@Level1ID=$WireSpeedID]/@ActuatorName,1,4)"/>
		</xsl:variable>
		<xsl:value-of select="$WS"/>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- -->
	<!-- -->
	<!-- Returns the assigned number for the scan level control (used in bool10_ty structures in AGC and Speed)-->
	<xsl:template name="GetAssignment">
		<xsl:param name="Name"/>
		<xsl:variable name="nWT">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDWeight])"/>
		</xsl:variable>
		<xsl:variable name="nMO">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDMoisture])"/>
		</xsl:variable>
		<xsl:variable name="nYH">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDYankeeHood])"/>
		</xsl:variable>
		<xsl:variable name="nAS">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDAsh])"/>
		</xsl:variable>
		<xsl:variable name="nCT">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDCoatWeight])"/>
		</xsl:variable>
		<xsl:variable name="nOP">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDOpacity])"/>
		</xsl:variable>
		<xsl:variable name="nGL">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDGloss])"/>
		</xsl:variable>
		<xsl:variable name="nOT">
			<xsl:value-of select="count(/xml/rs:data/z:row/tblScanLevelControls[@Type=$MDOptional])"/>
		</xsl:variable>
		<xsl:variable name="Type">
			<xsl:value-of select="/xml/rs:data/z:row/tblScanLevelControls[@Name=$Name]/@Type"/>
		</xsl:variable>
		<xsl:choose>
			<!-- -->
			<!-- pqt, 2004/11/18: support more than 1 WT-loop. No more hard code to value of 2. -->
			<!--
			<xsl:when test="$Type=$MDWeight">2</xsl:when>
			-->
			<xsl:when test="$Type=$MDWeight">
				<xsl:value-of select="1+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDMoisture">
				<xsl:value-of select="1+$nWT+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDYankeeHood">
				<xsl:value-of select="1+$nWT+$nMO+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDAsh">
				<xsl:value-of select="1+$nWT+$nMO+$nYH+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDCoatWeight">
				<xsl:value-of select="1+$nWT+$nMO+$nYH+$nAS+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDOpacity">
				<xsl:value-of select="1+$nWT+$nMO+$nYH+$nAS +$nCT + number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDGloss">
				<xsl:value-of select="1+$nWT+$nMO+$nYH+$nAS +$nCT +$nOP+number(substring($Name,3,2))"/>
			</xsl:when>
			<xsl:when test="$Type=$MDOptional">
				<xsl:value-of select="1+$nWT+$nMO+$nYH+$nAS +$nCT +$nOP+$nGL+number(substring($Name,3,2))"/>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	<!-- -->
	<!-- -->
	<!-- -->
	<!-- -->
	<!--	
		GetJetVelocityMode 
		Gets Jet Velocity Mode description
		
		Input Paramters
		mode		Jet Velocity Mode type
	-->
	<xsl:template name="GetJetVelocityMode">
		<xsl:param name="mode"/>
		<xsl:choose>
			<xsl:when test="$mode=1">Standard total head</xsl:when>
			<xsl:when test="$mode=2">Level plus reference pressure</xsl:when>
			<xsl:when test="$mode=3">Total head minus slice height</xsl:when>
			<xsl:when test="$mode=4">Total flow and slice opening</xsl:when>
			<xsl:when test="$mode=5">Total head and slice</xsl:when>
			<xsl:when test="$mode=6">Total flow, recirculation and slice</xsl:when>
			<xsl:when test="$mode=7">User defined</xsl:when>
			<xsl:otherwise>Unknown mode <xsl:value-of select="$mode"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--	
		GetL1OutputTypeName
		Gets Level 1 Output type description
		
		Input Paramters
		Level1ID		Level 1 Control ID
	-->
	<xsl:template name="GetL1OutputTypeName">
		<xsl:param name="Level1ID"/>
		<xsl:variable name="outType" select="//tblLevel1Controls[@Level1ID=$Level1ID]/@OutputType"/>
		<xsl:choose>
			<xsl:when test="$outType=1">Analog</xsl:when>
			<xsl:when test="$outType=2">Digital</xsl:when>
			<xsl:when test="$outType=3">Cascade Setp Station</xsl:when>
			<xsl:when test="$outType=4">Direct Setp Station</xsl:when>
			<xsl:otherwise>Unknown output type <xsl:value-of select="$outType"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--	
		GetL1TypeName
		Gets Level 1 Control  type description
		
		Input Paramters
		Level1ID		Level 1 Control ID
		tbl				0 (default) use tblLevel1Controls
						1 use tblLevel1Measurements
	-->
	<xsl:template name="GetL1TypeName">
		<xsl:param name="Level1ID"/>
		<xsl:param name="tbl" select="0"/>
		<xsl:variable name="Type">
			<xsl:choose>
				<xsl:when test="$tbl=0">
					<xsl:value-of select="//tblLevel1Controls[@Level1ID=$Level1ID]/@ControlType"/>
				</xsl:when>
				<xsl:when test="$tbl=1">
					<xsl:value-of select="//tblLevel1Measurements[@Level1ID=$Level1ID]/@Type"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="//tblLevel1Controls[@Level1ID=$Level1ID]/@ControlType"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$Type = 1">Stock</xsl:when>
			<xsl:when test="$Type = 2">Steam</xsl:when>
			<xsl:when test="$Type = 3">Speed</xsl:when>
			<xsl:when test="$Type = 4">Clay</xsl:when>
			<xsl:when test="$Type = 5">Titanium</xsl:when>
			<xsl:when test="$Type = 6">Coater Blade</xsl:when>
			<xsl:when test="$Type = 7">Ratio Bias</xsl:when>
			<xsl:when test="$Type = 8">Temperature</xsl:when>
			<xsl:when test="$Type = 9">Consistency</xsl:when>
			<xsl:when test="$Type = 10">Headbox Level</xsl:when>
			<xsl:when test="$Type = 11">Recirculation</xsl:when>
			<xsl:when test="$Type = 12">Stream Flow</xsl:when>
			<xsl:when test="$Type = 13">Slice</xsl:when>
			<xsl:when test="$Type = 14">Air Pad</xsl:when>
			<xsl:when test="$Type = 15">Total Head</xsl:when>
			<xsl:when test="$Type = 16">Reel Speed</xsl:when>
			<xsl:when test="$Type = 17">Wire Speed</xsl:when>
			<xsl:when test="$Type = 18">Dye Flow</xsl:when>
			<xsl:when test="$Type = 19">Shaft Speed</xsl:when>
			<xsl:when test="$Type = 20">Hood Temp</xsl:when>
			<xsl:when test="$Type = 21">Yankee Pressure</xsl:when>
			<xsl:when test="$Type = 22">Retention Aid</xsl:when>
			<xsl:when test="$Type = 23">Mc Level</xsl:when>
			<xsl:when test="$Type = 24">Broke Flow</xsl:when>
			<xsl:when test="$Type = 25">RF Power</xsl:when>
			<xsl:when test="$Type = 26">Ash Conc</xsl:when>
			<xsl:when test="$Type = 27">WW cons</xsl:when>
			<xsl:when test="$Type = 28">Optional Flow</xsl:when>
			<xsl:when test="$Type = 9999">Other</xsl:when>
			<xsl:otherwise>Unknown type <xsl:value-of select="$Type"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!--	
		GetMDMachineTypeName
		Gets MD Machine type description
		
		Input Paramters
		MachineTypeID		Machine Type ID
	-->
	<xsl:template name="GetMDMachineTypeName">
		<xsl:param name="MachineTypeID"/>
		<xsl:choose>
			<xsl:when test="$MachineTypeID=$MDSingleStock">Single Stock</xsl:when>
			<xsl:when test="$MachineTypeID=$MDMultiStock">Multi Stock</xsl:when>
			<xsl:otherwise>Unknown Machine Type</xsl:otherwise>
		</xsl:choose>
	</xsl:template>	
	
	<!--	
		GetUnitsTypeName
		Gets MD Machine units type description
		
		Input Paramters
		UnitsTypeID		Units Type ID
	-->
	<xsl:template name="GetUnitsTypeName">
		<xsl:param name="UnitsTypeID"/>
		<xsl:choose>
			<xsl:when test="$UnitsTypeID=$MDSingleStock">English</xsl:when>
			<xsl:when test="$UnitsTypeID=$MDMultiStock">Metric</xsl:when>
			<xsl:otherwise>Unknown Units Type</xsl:otherwise>
		</xsl:choose>
	</xsl:template>	
	
	<!--	
		CheckString
		Check for spaces and other non valid characters and replace with underscores
		
		Input Paramters
		InputString		Input string
	-->
	<xsl:template name="CheckString">
		<xsl:param name="InputString"/>
		<xsl:value-of select='translate($InputString," !@#%^*()+:;,=","______________")'/>
	</xsl:template>
</xsl:stylesheet>
