<?xml version="1.0" encoding="UTF-8"?>
<!-- ServIS-QCS.xslt
Description:
This file is used to generate the ServIS installation description for the QCS Monitor of SCX100.

Notes:
This file is compatible with the msxml / msxsl 4.0 XML SP1 parser and transform tools.

History:
2016-03-22	Original	A. Zehnpfund
2017-03-08	AZ	Added QCS 6.0 SP1, NP800 and changed PG to 4223
2017-04-21	AZ	Changed ServIS schema from 4.1 to 4.3
2017-10-17	AZ	Removed import of NodeTypes.xslt, which is already included by Globals.xslt, because it caused error message on X64 systems
2018-04-19  AZ  Added ProductGroup element to Configuration elements to support Technical Details for PACT version of SCX
2018-04-24	AZ	Changed ServIS schema from 4.3 to 4.5
2018-11-23	AZ	Added support for QCS800xA 6.0 SP4
2019-07-16      ESWAR  Added support for QCS800xA 6.1
2021-08-03  Drakshayani Added Support for QCS 800xa 6.1 SP1 
2023-09-28	AZ	Fixed missing configurations for NP800 and several sensors (Color, HPIR-R, Difference, Twist) and changed PG to 4223

-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:rs="urn:schemas-microsoft-com:rowset" 
xmlns:z="#RowsetSchema" 
xmlns:abb="http://www.abb.com/AutomationTechnologyProducts"
xmlns:ms="urn:schemas-microsoft-com:xslt"
xmlns="http://servis.abb.com/xmlschema/ServIS_Schema_V4_5.xsd" 
xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
>
	<!-- 
	******************************************************
	Imports
	******************************************************		
	-->
	<xsl:import href="Globals.xslt"/>
	<xsl:import href="MDControl.xslt"/>
	<xsl:import href="Actuators.xslt"/>
	<xsl:import href="Measurements.xslt"/>
	<xsl:output method="xml" omit-xml-declaration="yes" version="1.0" encoding="UTF-8" indent="yes"/>
	<!-- don't output text by default -->
	<xsl:template match="text()"/>
	<!-- Global variables -->
	<xsl:variable name="ProductGroup">4223</xsl:variable>
	<xsl:variable name="ABBManufacturer">9AAE202578</xsl:variable>
	<xsl:variable name="IncludeManufacturers">1</xsl:variable>
	<xsl:variable name="IncludeTechnicalDetails">1</xsl:variable>
	<!-- -->
	<xsl:template match="//z:row">
	
		<!-- Schema location -->
		<xsl:attribute name="xsi:schemaLocation">http://servis.abb.com/xmlschema/ServIS_Schema_V4_5.xsd ServIS_Schema_V4_5.xsd</xsl:attribute>	
		
		<!-- Company Definitions -->
		<Company defID="9AAE202578">
			<GlobalID Type="GUID" Code="9AAE202578" />
			<Name>9AAE202578</Name>
		</Company>

		<!-- Product Definitions -->
		<Product defID="SERV0003RD">
			<GlobalID Type="ABB Products" Code="SERV0003RD" />
			<Name>(3rd Party Product)</Name>
		</Product>
		<Product defID="UNKNOWN">
			<GlobalID Type="ABB Products" Code="UNKNOWN" />
			<Name>(Other ABB Product)</Name>
		</Product>
		<Product defID="9AAC131476">
			<GlobalID Type="ABB Products" Code="9AAC131476" />
			<Name>QCS800xA</Name>
		</Product>
		<Product defID="9AAC181641">
			<GlobalID Type="ABB Products" Code="9AAC181641" />
			<Name>QCS800xA System Documents</Name>
		</Product>
		<Product defID="9AAC123378">
			<GlobalID Type="ABB Products" Code="9AAC123378" />
			<Name>Actuators</Name>
		</Product>
		<Product defID="9AAC123371">
			<GlobalID Type="ABB Products" Code="9AAC123371" />
			<Name>Communications</Name>
		</Product>
		<Product defID="9AAC129640">
			<GlobalID Type="ABB Products" Code="9AAC129640" />
			<Name>Legacy Links</Name>
		</Product>
		<Product defID="9AAC123372">
			<GlobalID Type="ABB Products" Code="9AAC123372" />
			<Name>Controls</Name>
		</Product>
		<Product defID="9AAC123404">
			<GlobalID Type="ABB Products" Code="9AAC123404" />
			<Name>Color Controls</Name>
		</Product>
		<Product defID="9AAC123406">
			<GlobalID Type="ABB Products" Code="9AAC123406" />
			<Name>Cross Direction Controls</Name>
		</Product>
		<Product defID="9AAC123407">
			<GlobalID Type="ABB Products" Code="9AAC123407" />
			<Name>Machine Direction Controls</Name>
		</Product>
		<Product defID="9AAC158561">
			<GlobalID Type="ABB Products" Code="9AAC158561" />
			<Name>Multivariable Cross Direction Controls</Name>
		</Product>
		<Product defID="9AAC129514">
			<GlobalID Type="ABB Products" Code="9AAC129514" />
			<Name>Optimizing Controls</Name>
		</Product>
		<Product defID="9AAC123409">
			<GlobalID Type="ABB Products" Code="9AAC123409" />
			<Name>Wet End Controls</Name>
		</Product>
		<Product defID="9AAC123417">
			<GlobalID Type="ABB Products" Code="9AAC123417" />
			<Name>Measurement Scanners</Name>
		</Product>
		<Product defID="9AAC128575">
			<GlobalID Type="ABB Products" Code="9AAC128575" />
			<Name>Classic Measurement Scanners</Name>
		</Product>
		<Product defID="9AAC135176">
			<GlobalID Type="ABB Products" Code="9AAC135176" />
			<Name>NP1200</Name>
		</Product>
		<Product defID="9AAC135175">
			<GlobalID Type="ABB Products" Code="9AAC135175" />
			<Name>NP700</Name>
		</Product>
		<Product defID="9AAC189948">
			<GlobalID Type="ABB Products" Code="9AAC189948" />
			<Name>NP800</Name>
		</Product>
		<Product defID="9AAC135177">
			<GlobalID Type="ABB Products" Code="9AAC135177" />
			<Name>Reflection Network Platform</Name>
		</Product>
		<Product defID="9AAC207899">
			<GlobalID Type="ABB Products" Code="9AAC207899" />
			<Name>Reflection SP</Name>
		</Product>
		<Product defID="9AAC207901">
			<GlobalID Type="ABB Products" Code="9AAC207901" />
			<Name>SP 1200</Name>
		</Product>
		<Product defID="9AAC207902">
			<GlobalID Type="ABB Products" Code="9AAC207902" />
			<Name>SP 700</Name>
		</Product>
		<Product defID="9AAC123374">
			<GlobalID Type="ABB Products" Code="9AAC123374" />
			<Name>Measurements</Name>
		</Product>
		<Product defID="9AAC123411">
			<GlobalID Type="ABB Products" Code="9AAC123411" />
			<Name>Ash Measurements</Name>
		</Product>
		<Product defID="9AAC123412">
			<GlobalID Type="ABB Products" Code="9AAC123412" />
			<Name>Caliper Measurements</Name>
		</Product>
		<Product defID="9AAC123413">
			<GlobalID Type="ABB Products" Code="9AAC123413" />
			<Name>Coat Weight Measurements</Name>
		</Product>
		<Product defID="9AAC123414">
			<GlobalID Type="ABB Products" Code="9AAC123414" />
			<Name>Color Measurements</Name>
		</Product>
		<Product defID="9AAC187559">
			<GlobalID Type="ABB Products" Code="9AAC187559" />
			<Name>Smart Color Measurements</Name>
		</Product>
		<Product defID="9AAC187560">
			<GlobalID Type="ABB Products" Code="9AAC187560" />
			<Name>High Performance Color Measurements</Name>
		</Product>
		<Product defID="9AAC129642">
			<GlobalID Type="ABB Products" Code="9AAC129642" />
			<Name>Computed Measurements</Name>
		</Product>
		<Product defID="9AAC123415">
			<GlobalID Type="ABB Products" Code="9AAC123415" />
			<Name>Fiber Orientation Measurements</Name>
		</Product>
		<Product defID="9AAC123416">
			<GlobalID Type="ABB Products" Code="9AAC123416" />
			<Name>Gloss Measurements</Name>
		</Product>
		<Product defID="9AAC168893">
			<GlobalID Type="ABB Products" Code="9AAC168893" />
			<Name>HPIR-T Transmission Moisture Measurements</Name>
		</Product>
		<Product defID="9AAF622603">
			<GlobalID Type="ABB Products" Code="9AAF622603" />
			<Name>HPIR-R Reflection Moisture Measurement</Name>
		</Product>
		<Product defID="9AAC129682">
			<GlobalID Type="ABB Products" Code="9AAC129682" />
			<Name>Microwave Moisture Measurements</Name>
		</Product>
		<Product defID="9AAC129684">
			<GlobalID Type="ABB Products" Code="9AAC129684" />
			<Name>Reflection Moisture Measurements</Name>
		</Product>
		<Product defID="9AAC129683">
			<GlobalID Type="ABB Products" Code="9AAC129683" />
			<Name>Transmission Moisture Measurements</Name>
		</Product>
		<Product defID="9AAC159456">
			<GlobalID Type="ABB Products" Code="9AAC159456" />
			<Name>Optical Caliper Measurements</Name>
		</Product>
		<Product defID="9AAC123420">
			<GlobalID Type="ABB Products" Code="9AAC123420" />
			<Name>Optical Measurements</Name>
		</Product>
		<Product defID="9AAC123422">
			<GlobalID Type="ABB Products" Code="9AAC123422" />
			<Name>Sheet Width Measurements</Name>
		</Product>
		<Product defID="9AAC123423">
			<GlobalID Type="ABB Products" Code="9AAC123423" />
			<Name>Temperature Measurements</Name>
		</Product>
		<Product defID="9AAC174369">
			<GlobalID Type="ABB Products" Code="9AAC174369" />
			<Name>Basis Weight</Name>
		</Product>
		<Product defID="9AAC174370">
			<GlobalID Type="ABB Products" Code="9AAC174370" />
			<Name>HPIR-FW Fiber Weight</Name>
		</Product>
		<Product defID="9AAC128598">
			<GlobalID Type="ABB Products" Code="9AAC128598" />
			<Name>SV 2_1_1</Name>
		</Product>
		<Product defID="9AAC128599">
			<GlobalID Type="ABB Products" Code="9AAC128599" />
			<Name>SV 2_1_2</Name>
		</Product>
		<Product defID="9AAC128600">
			<GlobalID Type="ABB Products" Code="9AAC128600" />
			<Name>SV 3_1_1</Name>
		</Product>
		<Product defID="9AAC128601">
			<GlobalID Type="ABB Products" Code="9AAC128601" />
			<Name>SV 4_0_0</Name>
		</Product>
		<Product defID="9AAC128602">
			<GlobalID Type="ABB Products" Code="9AAC128602" />
			<Name>SV 4_1_0</Name>
		</Product>
		<Product defID="9AAC131484">
			<GlobalID Type="ABB Products" Code="9AAC131484" />
			<Name>SV 4_2_1</Name>
		</Product>
		<Product defID="9AAC135179">
			<GlobalID Type="ABB Products" Code="9AAC135179" />
			<Name>SV 5_0_SP1</Name>
		</Product>
		<Product defID="9AAC158563">
			<GlobalID Type="ABB Products" Code="9AAC158563" />
			<Name>SV 5_0_SP2</Name>
		</Product>
		<Product defID="9AAC167482">
			<GlobalID Type="ABB Products" Code="9AAC167482" />
			<Name>SV 5_0_SP3</Name>
		</Product>
		<Product defID="9AAC172508">
			<GlobalID Type="ABB Products" Code="9AAC172508" />
			<Name>SV 5_1_0</Name>
		</Product>
		<Product defID="9AAC175074">
			<GlobalID Type="ABB Products" Code="9AAC175074" />
			<Name>SV 5_1_SP1</Name>
		</Product>
		<Product defID="9AAC181183">
			<GlobalID Type="ABB Products" Code="9AAC181183" />
			<Name>SV 5_1_SP2</Name>
		</Product>
		<Product defID="9AAC186655">
			<GlobalID Type="ABB Products" Code="9AAC186655" />
			<Name>SV 6_0</Name>
		</Product>
		<Product defID="9AAC189949">
			<GlobalID Type="ABB Products" Code="9AAC189949" />
			<Name>SV 6_0_SP1</Name>
		</Product>
		<Product defID="9AAC404570">
			<GlobalID Type="ABB Products" Code="9AAC404570" />
			<Name>SV 6_0_SP2</Name>
		</Product>
		<Product defID="9AAC405180">
			<GlobalID Type="ABB Products" Code="9AAC405180" />
			<Name>SV 6_0_SP3</Name>
		</Product>
		<Product defID="9AAC426172">
			<GlobalID Type="ABB Products" Code="9AAC426172" />
			<Name>SV 6_0_SP4</Name>
		</Product>

		<Product defID="9AAF600917">
			<GlobalID Type="ABB Products" Code="9AAF600917" />
			<Name>SV 6_1</Name>
		</Product>
		
		<Product defID="9AAF618457">
			<GlobalID Type="ABB Products" Code="9AAF618457" />
			<Name>SV 6_1_SP1</Name>
		</Product>
		<Product defID="9AAF621020">
			<GlobalID Type="ABB Products" Code="9AAF621020" />
			<Name>SV 6_1_SP2</Name>
		</Product>
		<Product defID="9AAF625741">
			<GlobalID Type="ABB Products" Code="9AAF625741" />
			<Name>SV 6_1_SP3</Name>
		</Product>
		<Product defID="9AAF629198">
			<GlobalID Type="ABB Products" Code="9AAF629198" />
			<Name>SV 6_1_SP4</Name>
		</Product>
		<!-- QCS800xA -->
		<xsl:element name="Installation">
			<xsl:element name="Product">
				<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
				<xsl:attribute name="refID">9AAC131476</xsl:attribute>
			</xsl:element>
			<xsl:element name="Description">QCS800xA</xsl:element>
			<Type>QCS, Quality Control System</Type>
			<xsl:element name="SerialNumber"><xsl:value-of select="@JobOrder"/></xsl:element>
			<xsl:element name="TagName">QCS800xA</xsl:element>
			<xsl:call-template name="Manufacturer" />
			<xsl:element name="ManufacturingOrder"><xsl:value-of select="@JobOrder"/></xsl:element>
			<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
			<xsl:element name="Status">Running</xsl:element>
			<xsl:if test="$IncludeTechnicalDetails = 1">
				<xsl:variable name="MachineType">
					<xsl:call-template name="GetMDMachineTypeName">
						<xsl:with-param name="MachineTypeID">
							<xsl:value-of select="@MachineType"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:variable>
				<xsl:variable name="UnitsType">
					<xsl:call-template name="GetUnitsTypeName">
						<xsl:with-param name="UnitsTypeID">
							<xsl:value-of select="@Units"/>
						</xsl:with-param>
					</xsl:call-template>
				</xsl:variable>
				<Configuration>
					<Name>Job Order</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="@JobOrder"/></Value>
				</Configuration>
				<Configuration>
					<Name>Machine Name</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="@MachineName"/></Value>
				</Configuration>
				<Configuration>
					<Name>Machine Type</Name>
					<Type>Enum</Type>
					<ProductGroup>4223</ProductGroup>
					<Value>
						<xsl:choose>
							<xsl:when test="starts-with($MachineType,'Unknown')">Unknown</xsl:when>
							<xsl:otherwise><xsl:value-of select="$MachineType"/></xsl:otherwise>
						</xsl:choose>
					</Value>
				</Configuration>
				<Configuration>
					<Name>Unit Type</Name>
					<Type>Enum</Type>
					<ProductGroup>4223</ProductGroup>
					<Value>
						<xsl:choose>
							<xsl:when test="starts-with($UnitsType,'Unknown')">Unknown</xsl:when>
							<xsl:otherwise><xsl:value-of select="$UnitsType"/></xsl:otherwise>
						</xsl:choose>
					</Value>
				</Configuration>
				<Configuration>
					<Name>Ream Size</Name>
					<Type>Numeric</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="@ReamSize"/></Value>
				</Configuration>
				<Configuration>
					<Name>Quality Control Connectivity Server</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="$MainNodeName"/></Value>
				</Configuration>
				<xsl:if test="//tblNodes[@NodeType=$CDNode]">
					<Configuration>
						<Name>Secondary Quality Control Connectivity Server</Name>
						<Type>Text</Type>
						<ProductGroup>4223</ProductGroup>
						<Value><xsl:value-of select="$SecondaryNodeName"/></Value>
					</Configuration>
				</xsl:if>
				<xsl:if test="count(//tblHMCsByJobOrder)>0">
					<Configuration>
						<Name>MCD Connectivity Server</Name>
						<Type>Text</Type>
						<ProductGroup>4223</ProductGroup>
						<Value><xsl:value-of select="$HMCControlNodeName"/></Value>
					</Configuration>
				</xsl:if>
				<Configuration>
					<Name>AC800M Connectivity Server</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="$AC800MNode"/></Value>
				</Configuration>
				<Configuration>
					<Name>Aspect Server</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value><xsl:value-of select="$PPAServerNode"/></Value>
				</Configuration>
        <Configuration>
					<Name>Software Version</Name>
					<Type>Text</Type>
					<ProductGroup>4223</ProductGroup>
					<Value></Value>
				</Configuration>
				<xsl:if test="$ColorControlExists='true'">
					<Configuration>
						<Name>Color Control Server</Name>
						<Type>Text</Type>
						<ProductGroup>4223</ProductGroup>
						<Value><xsl:value-of select="$ColorControlNode"/></Value>
					</Configuration>
				</xsl:if>
			</xsl:if>

			<!-- Scanners -->
			<xsl:element name="Installation">
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<xsl:attribute name="refID">9AAC123417</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">QCS Measurements</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>
				<xsl:for-each select="//z:row/tblScanners">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">
								<xsl:choose>
									<xsl:when test="@ScannerTypeID = $SP1200">9AAC207901</xsl:when>
									<xsl:when test="@ScannerTypeID = $SP700">9AAC207902</xsl:when>
									<xsl:when test="@ScannerTypeID = $SPReflection">9AAC207899</xsl:when>
									<xsl:when test="@ScannerTypeID = $NA1200">9AAC135176</xsl:when>
									<xsl:when test="@ScannerTypeID = $NA700">9AAC135175</xsl:when>
									<xsl:when test="@ScannerTypeID = $NAReflection">9AAC135177</xsl:when>
									<xsl:when test="@ScannerTypeID = $NP800">9AAC189948</xsl:when>
									<xsl:otherwise>9AAC128575</xsl:otherwise>
								</xsl:choose>
							</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description"><xsl:value-of select="@oName"/></xsl:element>
						<xsl:element name="Type">QCS Scanner</xsl:element>
						<xsl:element name="TypeCode">
							<xsl:choose>
								<xsl:when test="@ScannerTypeID = $SP1200">SP1200</xsl:when>
								<xsl:when test="@ScannerTypeID = $SP700">SP700</xsl:when>
								<xsl:when test="@ScannerTypeID = $SPReflection">SPReflection</xsl:when>
								<xsl:when test="@ScannerTypeID = $NA1200">NP1200</xsl:when>
								<xsl:when test="@ScannerTypeID = $NA700">NP700</xsl:when>
								<xsl:when test="@ScannerTypeID = $NAReflection">NPReflection</xsl:when>
								<xsl:when test="@ScannerTypeID = $NP800">NP800</xsl:when>
								<xsl:otherwise>Frame</xsl:otherwise>
							</xsl:choose>
						</xsl:element>
						<xsl:element name="TagName"><xsl:value-of select="@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>IP Address</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="@ScannerIPAddress"/></Value>
							</Configuration>
							<Configuration>
								<Name>Number of Databoxes</Name>
								<Type>Numeric</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="@NumDataBoxes"/></Value>
							</Configuration>
						</xsl:if>
						<xsl:for-each select="./tblMeasurements">
							<xsl:variable name="mName">
								<xsl:call-template name="MeasName">
									<xsl:with-param name="SensorType">
										<xsl:value-of select="@SensorType"/>
									</xsl:with-param>
									<xsl:with-param name="MeasurementType">
										<xsl:value-of select="@MeasurementTypeID"/>
									</xsl:with-param>
								</xsl:call-template>
							</xsl:variable>
							<xsl:variable name="senstype" select="@SensorType"/>
							<xsl:variable name="measName" select="@MeasName"/>
							<xsl:choose>
								<xsl:when test="@SensorType = $S_AirColumn" />
								<xsl:when test="@SensorType = $S_ApparentDensity" />
								<xsl:when test="@SensorType = $S_ConditionedWeight" />
								<xsl:otherwise>
									<xsl:element name="Installation">
										<xsl:element name="Product">
											<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
											<xsl:attribute name="refID">
												<xsl:choose>
													<xsl:when test="@SensorType = $S_Ash">9AAC123411</xsl:when>
													<xsl:when test="@SensorType = $S_OptiPak">9AAC123420</xsl:when>
													<xsl:when test="@SensorType = $S_Caliper">9AAC123412</xsl:when>
													<xsl:when test="@SensorType = $S_ColorTop">9AAC187559</xsl:when>
													<xsl:when test="@SensorType = $S_ColorBottom">9AAC187559</xsl:when>
													<xsl:when test="@SensorType = $S_GlossTop">9AAC123416</xsl:when>
													<xsl:when test="@SensorType = $S_GlossBottom">9AAC123416</xsl:when>
													<xsl:when test="@SensorType = $S_IRMoisture">9AAC129683</xsl:when>
													<xsl:when test="@SensorType = $S_MicrowaveMoisture">9AAC129682</xsl:when>
													<xsl:when test="@SensorType = $S_SheetTemperature">9AAC123423</xsl:when>
													<xsl:when test="@SensorType = $S_UniqueSP">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_BasisWeight">9AAC174369</xsl:when>
													<xsl:when test="@SensorType = $S_XRayWeight">9AAC174369</xsl:when>
													<xsl:when test="@SensorType = $S_IRCoatWeightTop">9AAC123413</xsl:when>
													<xsl:when test="@SensorType = $S_IRCoatWeightBottom">9AAC123413</xsl:when>
													<xsl:when test="@SensorType = $S_FiberOrientationTop">9AAC123415</xsl:when>
													<xsl:when test="@SensorType = $S_FiberOrientationBottom">9AAC123415</xsl:when>
													<xsl:when test="@SensorType = $S_CoatWeight">9AAC123413</xsl:when>
													<xsl:when test="@SensorType = $S_WeightCompensatedMoisture">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_WaterBalance">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_TissueWeight">9AAC174369</xsl:when>
													<xsl:when test="@SensorType = $S_UniqueCalcMeas">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_Difference">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_TwistIndex">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_Ratio">9AAC129642</xsl:when>
													<xsl:when test="@SensorType = $S_OpticalCaliper">9AAC159456</xsl:when>
													<xsl:when test="@SensorType = $S_HPIRTMoisture">9AAC168893</xsl:when>
													<xsl:when test="@SensorType = $S_HPIRWeight">9AAC174370</xsl:when>
													<xsl:when test="@SensorType = $S_SurfaceVariation">9AAC159456</xsl:when>
													<xsl:when test="@SensorType = $S_HPColorTop">9AAC187560</xsl:when>
													<xsl:when test="@SensorType = $S_HPColorBottom">9AAC187560</xsl:when>
													<xsl:when test="@SensorType = $S_HPColorProfileTop">9AAC187560</xsl:when>
													<xsl:when test="@SensorType = $S_HPColorProfileBottom">9AAC187560</xsl:when>
													<xsl:when test="@SensorType = $S_HPIRRMoisture">9AAF622603</xsl:when>
													<xsl:otherwise>
														<xsl:value-of select="@SensorType"/>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:attribute>
										</xsl:element>
										<xsl:element name="Description">
											<xsl:choose>
												<xsl:when test="@SensorType = $S_ColorTop"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_ColorBottom"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_HPColorTop"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_HPColorBottom"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_HPColorProfileTop"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_HPColorProfileBottom"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_GlossTop"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_GlossBottom"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_FiberOrientationTop"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:when test="@SensorType = $S_FiberOrientationBottom"><xsl:value-of select="@oName"/></xsl:when>
												<xsl:otherwise>
													<xsl:value-of select="$measName"/>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:element>
										<xsl:element name="Type">QCS Sensor</xsl:element>
										<xsl:element name="TypeCode"><xsl:value-of select="$mName"/></xsl:element>
										<xsl:element name="TagName"><xsl:value-of select="@Description"/></xsl:element>
										<xsl:call-template name="Manufacturer" />
										<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
										<xsl:element name="Status">Running</xsl:element>
										<xsl:variable name="num" select="count(preceding-sibling::*[(@MeasurementTypeID = current()/@MeasurementTypeID) and (../@ScannerID = current()/@ScannerID)]) + 1"/>
										<!-- measurement nickname (WT1, MO1, ...) -->
										<xsl:variable name="nickname">
											<xsl:call-template name="SP_Nickname">
												<xsl:with-param name="SensorType">
													<xsl:value-of select="@SensorType"/>
												</xsl:with-param>
												<xsl:with-param name="MeasurementType">
													<xsl:value-of select="@MeasurementTypeID"/>
												</xsl:with-param>
												<xsl:with-param name="MeasurementNumber">
													<xsl:value-of select="$num"/>
												</xsl:with-param>
											</xsl:call-template>
										</xsl:variable>
										<xsl:if test="$IncludeTechnicalDetails = 1">
											<Configuration>
												<Name>Measurements</Name>
												<Type>Text</Type>
												<ProductGroup>4223</ProductGroup>
												<Value><xsl:value-of select="$nickname"/></Value>
											</Configuration>
										</xsl:if>
									</xsl:element>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
						<!-- add sheet width measurement by default -->
						<Installation>
							<Product xsi:type="ProductReference" refID="9AAC123422" />
							<Description>EOS</Description>
							<xsl:element name="Type">QCS Sensor</xsl:element>
							<TagName>Sheet Width</TagName>
							<xsl:call-template name="Manufacturer" />
							<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
							<xsl:element name="Status">Running</xsl:element>
							<xsl:if test="$IncludeTechnicalDetails = 1">
								<Configuration>
									<Name>Measurements</Name>
									<Type>Text</Type>
									<ProductGroup>4223</ProductGroup>
									<Value>EOS</Value>
								</Configuration>
							</xsl:if>
						</Installation>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>

			<!-- L1 Measurements -->
			<xsl:element name="Installation">
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<xsl:attribute name="refID">9AAC123372</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">Level1 Measurements</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>

				<!-- L1 Measurements -->
				<xsl:for-each select="//z:row/tblLevel1Measurements">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123407</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description"><xsl:value-of select="@ActuatorName"/></xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TagName"><xsl:value-of select="@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="@TagName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>

			<!-- L1 Controls -->
			<xsl:element name="Installation">
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<xsl:attribute name="refID">9AAC123372</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">Level1 Controls</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>

				<!-- L1 Controls -->
				<xsl:for-each select="//z:row/tblLevel1Controls">
					<xsl:variable name="controlType">
						<xsl:call-template name="GetL1TypeName">
							<xsl:with-param name="Level1ID" select="@Level1ID"/>
						</xsl:call-template>
					</xsl:variable>
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123407</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">
							<xsl:value-of select="@ActuatorName"/>
						</xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TypeCode"><xsl:value-of select="$controlType"/></xsl:element>
						<xsl:element name="TagName"><xsl:value-of select="@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="@TagName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>

			<!-- Controls -->
			<xsl:element name="Installation">
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<xsl:attribute name="refID">9AAC123372</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">QCS Controls</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>

				<!-- MD Controls -->
				<xsl:for-each select="//z:row/tblScanLevelControls">
					<xsl:variable name="mdType">
						<xsl:call-template name="MD_Nickname">
							<xsl:with-param name="Name" select="@Name"/>
						</xsl:call-template>
					</xsl:variable>
					<xsl:variable name="actName">
						<xsl:call-template name="GetL1">
							<xsl:with-param name="Name" select="@Name"/>
						</xsl:call-template>
					</xsl:variable>
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123407</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">
							<xsl:value-of select="@Name"/>
						</xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TagName"><xsl:value-of select="$mdType"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="//tblMeasurements[@MeasurementID=current()/@MeasurementID]/@MeasName"/></Value>
							</Configuration>
							<Configuration>
								<Name>Actuators</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$actName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>

				<!-- CD Controls -->
				<xsl:for-each select="//z:row/tblClassicCDControls">
					<xsl:variable name="actType" select="//tblActuators[@ActuatorID=current()/@Actuator]/@ActuatorTypeName"/>
					<xsl:variable name="actDes" select="//tblActuators[@ActuatorID=current()/@Actuator]/@Description"/>
					<xsl:variable name="actName" select="//tblActuators[@ActuatorID=current()/@Actuator]/@oName"/>
					<xsl:variable name="actZones" select="//tblActuators[@ActuatorID=current()/@Actuator]/@NumberZones"/>
					<xsl:variable name="cdNode" select="//tblNodes[@NodeID=current()/@Node]/@NodeName"/>
					<xsl:variable name="cdM1ID" select="./tblCDMeasurements[position()=1]/@MeasurementID"/>
					<xsl:variable name="cdMeas1" select="//tblControlledMeasurements/tblMeasurements[@MeasurementID=$cdM1ID]/@MeasName"/>
					<xsl:variable name="cdScannerID1" select="//tblControlledMeasurements/tblMeasurements[@MeasurementID=$cdM1ID]/@ScannerID"/>
					<xsl:variable name="cdNumDataboxes" select="//tblScanners[@ScannerID=$cdScannerID1]/@NumDataBoxes"/>
					<xsl:variable name="cdM2ID" select="./tblCDMeasurements[position()=2]/@MeasurementID"/>
					<xsl:variable name="cdMeas2" select="//tblControlledMeasurements/tblMeasurements[@MeasurementID=$cdM2ID]/@MeasName"/>
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123406</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">
							<xsl:value-of select="@OID"/>
						</xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TagName"><xsl:value-of select="@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value>
									<xsl:value-of select="$cdMeas1"/>
									<xsl:if test="$cdMeas2">
										<xsl:text>, </xsl:text>
										<xsl:value-of select="$cdMeas2"/>
									</xsl:if>
								</Value>
							</Configuration>
							<Configuration>
								<Name>Actuators</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$actName"/></Value>
							</Configuration>
							<Configuration>
								<Name>Number of Databoxes</Name>
								<Type>Numeric</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$cdNumDataboxes"/></Value>
							</Configuration>
							<Configuration>
								<Name>Number of Zones</Name>
								<Type>Numeric</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$actZones"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>

				<!-- MCD Controls -->
				<xsl:for-each select="//z:row/tblHMCsByJobOrder/tblHMCCDControls">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC158561</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">
							<xsl:value-of select="parent::node()/@Description"/>
							<xsl:text> </xsl:text>
							<xsl:value-of select="@HMCControlName"/>
						</xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TagName"><xsl:value-of select="@HMCControlDescription"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value>
									<xsl:variable name="m1ID" select="./tblHMCControlMeas[@ControlMeasIndex=1]/@HMCMeasurementID"/>
									<xsl:value-of select="//tblHMCMeasbyHMC/tblHMCMeasurements[@HMCMeasurementID=$m1ID]/@HMCMeasShortName"/>
									<xsl:if test="./tblHMCControlMeas[@ControlMeasIndex=2]">
										<xsl:variable name="m2ID" select="./tblHMCControlMeas[@ControlMeasIndex=2]/@HMCMeasurementID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCMeasbyHMC/tblHMCMeasurements[@HMCMeasurementID=$m2ID]/@HMCMeasShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlMeas[@ControlMeasIndex=3]">
										<xsl:variable name="m3ID" select="./tblHMCControlMeas[@ControlMeasIndex=3]/@HMCMeasurementID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCMeasbyHMC/tblHMCMeasurements[@HMCMeasurementID=$m3ID]/@HMCMeasShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlMeas[@ControlMeasIndex=4]">
										<xsl:variable name="m4ID" select="./tblHMCControlMeas[@ControlMeasIndex=4]/@HMCMeasurementID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCMeasbyHMC/tblHMCMeasurements[@HMCMeasurementID=$m4ID]/@HMCMeasShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlMeas[@ControlMeasIndex=5]">
										<xsl:variable name="m5ID" select="./tblHMCControlMeas[@ControlMeasIndex=5]/@HMCMeasurementID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCMeasbyHMC/tblHMCMeasurements[@HMCMeasurementID=$m5ID]/@HMCMeasShortName"/>
									</xsl:if>
								</Value>
							</Configuration>
							<Configuration>
								<Name>Actuators</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value>
									<xsl:variable name="a1ID" select="./tblHMCControlActs[@ControlActIndex=1]/@HMCActuatorID"/>
									<xsl:value-of select="//tblHMCActsbyHMC/tblHMCActuators[@HMCActuatorID=$a1ID]/@HMCActuatorShortName"/>
									<xsl:if test="./tblHMCControlActs[@ControlActIndex=2]">
										<xsl:variable name="a2ID" select="./tblHMCControlActs[@ControlActIndex=2]/@HMCActuatorID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCActsbyHMC/tblHMCActuators[@HMCActuatorID=$a2ID]/@HMCActuatorShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlActs[@ControlActIndex=3]">
										<xsl:variable name="a3ID" select="./tblHMCControlActs[@ControlActIndex=3]/@HMCActuatorID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCActsbyHMC/tblHMCActuators[@HMCActuatorID=$a3ID]/@HMCActuatorShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlActs[@ControlActIndex=4]">
										<xsl:variable name="a4ID" select="./tblHMCControlActs[@ControlActIndex=4]/@HMCActuatorID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCActsbyHMC/tblHMCActuators[@HMCActuatorID=$a4ID]/@HMCActuatorShortName"/>
									</xsl:if>
									<xsl:if test="./tblHMCControlActs[@ControlActIndex=5]">
										<xsl:variable name="a5ID" select="./tblHMCControlActs[@ControlActIndex=5]/@HMCActuatorID"/>
										<xsl:text>, </xsl:text>
										<xsl:value-of select="//tblHMCActsbyHMC/tblHMCActuators[@HMCActuatorID=$a5ID]/@HMCActuatorShortName"/>
									</xsl:if>
								</Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>

				<!-- Color Controls -->
				<xsl:for-each select="//z:row/tblColorControls">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123404</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description"><xsl:value-of select="@CtrlName"/></xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TagName"><xsl:value-of select="@ColorDescription"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Measurements</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="//tblMeasurements[@MeasurementID=current()/@MeasID]/@oName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>

				<!-- General Controls -->
				<xsl:if test="//tblAdvancedControls/@AGC='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC129514</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Automatic Grade Change</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@Dryer='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC129514</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Dryer</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@Drystock='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123409</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Drystock</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@Headbox='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123409</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description"><xsl:value-of select="//tblHeadboxControls/@Name"/></xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TypeCode">Headbox Control</xsl:element>
						<xsl:element name="TagName"><xsl:value-of select="//tblHeadboxControls/@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Actuators</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="//tblLevel1Controls[@Level1ID=//tblHeadboxControls/@Level1Control]/@ActuatorName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@Speed='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123407</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description"><xsl:value-of select="//tblSpeedControls/@Name"/></xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TypeCode">Coordinated Speed Change</xsl:element>
						<xsl:element name="TagName"><xsl:value-of select="//tblSpeedControls/@Description"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Actuators</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="//tblLevel1Controls[@Level1ID=//tblSpeedControls/@Level1Control]/@ActuatorName"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@SpeedOpt='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC129514</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Speed Optimization</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@DryerLimitedSpeedOpt='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC129514</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Dryer Limited Speed Optimization</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
				<xsl:if test="//tblAdvancedControls/@ConsistencyCompensation='True'">
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC123409</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">Consistency Compensation</xsl:element>
						<Type>QCS Control</Type>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
					</xsl:element>
				</xsl:if>
			</xsl:element>

			<!-- Actuators -->
			<xsl:element name="Installation">
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<!-- Use CID for Communications here since Actuators CID is used in Market Category for ABB Actuators -->
					<xsl:attribute name="refID">9AAC123371</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">QCS Actuator Interfaces</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>
				<xsl:for-each select="//z:row/tblActuators">
					<xsl:variable name="actType" select="@ActuatorTypeName"/>
					<xsl:variable name="actDes" select="@Description"/>
					<xsl:variable name="actZones" select="@NumberZones"/>
					<xsl:variable name="actIPAddress" select="@ActuatorIPAddress"/>
					<xsl:element name="Installation">
						<xsl:element name="Product">
							<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
							<xsl:attribute name="refID">9AAC129640</xsl:attribute>
						</xsl:element>
						<xsl:element name="Description">
							<xsl:value-of select="@OID"/>
						</xsl:element>
						<Type>QCS Control</Type>
						<xsl:element name="TypeCode"><xsl:value-of select="$actType"/></xsl:element>
						<xsl:element name="TagName"><xsl:value-of select="$actDes"/></xsl:element>
						<xsl:call-template name="Manufacturer" />
						<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
						<xsl:element name="Status">Running</xsl:element>
						<xsl:if test="$IncludeTechnicalDetails = 1">
							<Configuration>
								<Name>Number of Zones</Name>
								<Type>Numeric</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$actZones"/></Value>
							</Configuration>
							<Configuration>
								<Name>IP Address</Name>
								<Type>Text</Type>
								<ProductGroup>4223</ProductGroup>
								<Value><xsl:value-of select="$actIPAddress"/></Value>
							</Configuration>
						</xsl:if>
					</xsl:element>
				</xsl:for-each>
			</xsl:element>

			<!-- System -->
			<!--<xsl:element name="Installation">
				--><!-- This element shall be replaced with the correct system version CID later by SCX100 --><!--
				<xsl:element name="Product">
					<xsl:attribute name="xsi:type">ProductReference</xsl:attribute>
					<xsl:attribute name="refID">9AAC181641</xsl:attribute>
				</xsl:element>
				<xsl:element name="Description">QCS System</xsl:element>
				<Type>QCS Control</Type>
				<xsl:call-template name="Manufacturer" />
				<xsl:element name="ProductGroup"><xsl:value-of select="$ProductGroup"/></xsl:element>
				<xsl:element name="Status">Running</xsl:element>
			</xsl:element>-->

		</xsl:element>

	</xsl:template>

	<!-- 
	******************************************************
	Main template
	******************************************************		
	-->
	<xsl:template match="/">
		<ServIS version="4.1">
			<xsl:apply-templates select="*"/>
		</ServIS>
	</xsl:template>
	<!-- 
	******************************************************
	Template to include manufacturer reference
	******************************************************		
	-->
	<xsl:template name="Manufacturer">
		<xsl:if test="$IncludeManufacturers = 1">
			<xsl:element name="Manufacturer">
				<xsl:attribute name="xsi:type">CompanyReference</xsl:attribute>
				<xsl:attribute name="refID"><xsl:value-of select="$ABBManufacturer"/></xsl:attribute>
			</xsl:element>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
